src/website/atcmentoring/blueprint.py
import json
from datetime import datetime
from flask import Blueprint, redirect, render_template, request, url_for, current_app as app
from flask_login import current_user as user, login_required, login_manager

from .atcmentoring import get_facility, get_avail_facilities
from .forms import NewMentorForm, EditMentorForm, NewTraineeForm, EditTraineeForm

from . import entities
from . import data
from ..auth import group_required, add_cid_to_group, remove_cid_from_group, get_user_for_cid

bp = Blueprint('atcmentoring', __name__, template_folder='templates', url_prefix='/atcmentoring')

@bp.route('/mentors/new', methods=['GET', 'POST'])
@login_required
@group_required('admin', 'training_director', 'atcmentor_editor')
def newmentor():
    non_mentors = data.get_non_mentors(app.db)

    form = NewMentorForm(non_mentors)
    if form.validate_on_submit():
        mentor = {
            'user' : get_user_for_cid(app.db, int(request.form['cid'])),
            'limit': int(request.form['limit']),
            'firs' : [key[4:].upper() for key, value in request.form.items() if 'fir_' in key and value == 'y'],
            'tmas' : [key[4:].upper() for key, value in request.form.items() if 'tma_' in key and value == 'y'],
        }
        mentor = entities.create_mentor(**mentor)
        data.add_mentor(app.db, mentor)
        add_cid_to_group(mentor['cid'], 'mentor')

        return redirect(url_for('atcmentoring.mentors_dashboard'))

    non_mentors = data.get_non_mentors(app.db)
    return render_template('atcmentoring/new_mentor.html', users=non_mentors, form=form)

@bp.route('/')
@login_required
@group_required('admin', 'training_director', 'mentor', 'atcmentor_editor')
def mentors_dashboard():
    mentors = list(data.get_mentors(app.db))

    view = {'mentors': mentors}
    return render_template('atcmentoring/mentors_dashboard.html', **view)

@bp.route("/mentors")
def mentors_public():
    mentors = data.get_mentors(app.db)

    return render_template('atcmentoring/mentors_public.html', mentors=mentors)

@bp.route('/mentors/<int:mentorid>/edit', methods=['GET', 'POST'])
@login_required
@group_required('admin', 'training_director', 'atcmentor_editor')
def editmentor(mentorid):
    mentor = data.get_mentor_for_cid(app.db, mentorid)

    form = EditMentorForm(mentorid)
    if form.validate_on_submit():
        if mentor:
            changes = {
                'limit': int(request.form['limit']),
                'firs' : [key[4:].upper() for key, value in request.form.items() if 'fir_' in key and value == 'y'],
                'tmas' : [key[4:].upper() for key, value in request.form.items() if 'tma_' in key and value == 'y'],
            }
            entities.update_mentor(mentor, **changes)
            data.save_mentor(app.db, mentor)
        return redirect(url_for('atcmentoring.mentors_dashboard'))

    view = {'mentor': mentor, 'mentor_json': json.loads(json.dumps(mentor, default=lambda y: y.__str__())), 'form':form}
    return render_template('atcmentoring/edit_mentor.html', **view)

@bp.route('/mentors/delete', methods=['POST'])
@login_required
@group_required('admin', 'training_director', 'atcmentor_editor')
def deletementor():
    mentor_cid = int(request.form['mentorid'])
    data.remove_mentor_for_cid(app.db, mentor_cid)
    remove_cid_from_group(mentor_cid, 'mentor')

    return redirect(url_for('atcmentoring.mentors_dashboard'))

@bp.route('/mentors/<int:mentorid>/trainees/new', methods=['GET', 'POST'])
@login_required
@group_required('admin', 'training_director', 'atcmentor_editor')
def newtrainee(mentorid):
    mentor = data.get_mentor_for_cid(app.db, mentorid)
    non_trainees = data.get_non_trainees(app.db, mentor)
    form = NewTraineeForm(non_trainees, mentor)
    if form.validate_on_submit():
        _at_val = request.form['atsimtest_validity']
        _at_val = datetime.strptime(_at_val, r'%d/%m/%Y') if _at_val else ''
        trainee = {
            'user'              : get_user_for_cid(app.db, int(request.form['trainieid'])),
            'facility'          : int(request.form['facility']),
            'firs'              : [key[4:].upper() for key, value in request.form.items() if 'fir_' in key and value == 'y'],
            'tmas'              : [key[4:].upper() for key, value in request.form.items() if 'tma_' in key and value == 'y'],
            'atsimtest_status'  : request.form['atsimtest'],
            'atsimtest_validity': _at_val,
        }
        trainee = entities.create_trainee(**trainee)
        entities.add_trainee(mentor, trainee)
        data.save_mentor(app.db, mentor)
        add_cid_to_group(trainee['cid'], 'trainee')
        return redirect(url_for('atcmentoring.trainees', mentorid=mentorid))

    view = {'mentor': mentor, 'form':form}
    return render_template('atcmentoring/new_trainee.html', **view)

@bp.route('/')
@bp.route('/mentors/<int:mentorid>/trainees')
@login_required
@group_required('admin', 'training_director', 'mentor', 'atcmentor_editor')
def trainees(mentorid=None):
    cid = mentorid if mentorid else user.cid
    mentor = data.get_mentor_for_cid(app.db, cid)

    for trainee in mentor['trainees']:
        _at_val = 'atsimtest_validity'
        if trainee[_at_val]:
            trainee[_at_val] = trainee[_at_val].strftime(r'%Y-%m-%d')

    view = {'mentor': mentor, 'get_facility': get_facility}
    return render_template('atcmentoring/trainees.html', **view)

@bp.route('/mentors/<int:mentorid>/trainees/<int:traineeid>/edit', methods=['GET', 'POST'])
@login_required
@group_required('admin', 'training_director', 'atcmentor_editor')
def edittrainee(mentorid, traineeid):
    mentor = data.get_mentor_for_cid(app.db, mentorid)
    trainee = entities.get_trainee_from_cid(mentor, traineeid)
    form = EditTraineeForm(traineeid, mentor)
    if form.validate_on_submit():
        _at_val = request.form['atsimtest_validity']
        _at_val = datetime.strptime(_at_val, r'%d/%m/%Y') if _at_val else ''
        changes = {
            'firs'              : [key[4:].upper() for key, value in request.form.items() if 'fir_' in key and value == 'on'],
            'tmas'              : [key[4:].upper() for key, value in request.form.items() if 'tma_' in key and value == 'on'],
            'facility'          : int(request.form['facility']),
            'atsimtest_status'  : request.form['atsimtest'],
            'atsimtest_validity': _at_val,
        }
        entities.update_trainee(mentor, trainee, **changes)
        data.save_mentor(app.db, mentor)
        return redirect(url_for('atcmentoring.trainees', mentorid=mentorid))

    view = {'mentor': mentor, 'trainee': trainee, 'form':form}
    return render_template('atcmentoring/edit_trainee.html', **view)

@bp.route('/mentors/<int:mentorid>/trainees/delete', methods=['POST'])
@login_required
@group_required('admin', 'training_director', 'atcmentor_editor')
def delete_trainee(mentorid):
    mentor = data.get_mentor_for_cid(app.db, mentorid)
    trainee_cid = int(request.form['trainieid'])
    trainee = entities.get_trainee_from_cid(mentor, trainee_cid)

    entities.remove_trainee(mentor, trainee)
    data.save_mentor(app.db, mentor)
    remove_cid_from_group(trainee['cid'], 'trainee')

    return redirect(url_for('atcmentoring.trainees', mentorid=mentorid))

src/website/atcmentoring/templates/atcmentoring/edit_mentor.html
{% extends 'dashboard/base.html' %}

{% block styles %}
  {{super()}}
  <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap-select@1.13.9/dist/css/bootstrap-select.min.css">
{% endblock %}
{% block scripts %}
  {{super()}}
  <script src="https://cdn.jsdelivr.net/npm/bootstrap-select@1.13.9/dist/js/bootstrap-select.min.js"></script>
  <script>
    mentor_firs = JSON.parse("{{mentor.firs|safe}}".replace(/'/g, '\"'))
    mentor_tmas = JSON.parse("{{mentor.tmas|safe}}".replace(/'/g, '\"'))

    if(Number("{{mentor.limit|safe}}") == 2)
      document.getElementById('limit').selectedIndex = "0"
    else if(Number("{{mentor.limit|safe}}") == 3)
      document.getElementById('limit').selectedIndex = "1"
    else if(Number("{{mentor.limit|safe}}") == 4)
      document.getElementById('limit').selectedIndex = "2"
    else if(Number("{{mentor.limit|safe}}") == 5)
      document.getElementById('limit').selectedIndex = "3"
    else if(Number("{{mentor.limit|safe}}") == 7)
      document.getElementById('limit').selectedIndex = "4"

    mentor_firs.forEach(element => {
      document.getElementById('fir_' + element.toLowerCase()).checked = true
    });

    mentor_tmas.forEach(element => {
      document.getElementById('tma_' + element.toLowerCase()).checked = true
    });
  </script>
{% endblock %}

{% block page_content %}
  <div class="d-sm-flex align-items-center justify-content-between mb-4">
    <h1 class="h3 mb-0 text-gray-800">Edit Mentor - {{mentor.name}}</h1>
  </div>
  <div class="row">
    <div class="col-xl-12 col-lg-12">
      <div class="card shadow mb-12">
        <div class="card-header py-3 d-flex flex-row align-items-center justify-content-between">

        </div>
        <div class="card-body">
          <form action="" method="post">
            {{ form.hidden_tag() }}
            <h5>Member</h5>
            <input class="form-control" value="{{mentor.cid}} - {{mentor.name}}" disabled></input>
            <br>
            <br>
            <h5>Limit</h5>
            {{ form.limit(class='form-control') }}
            <br>
            <h5>FIR</h5>
            <div class="form-check">
              <span style="margin-right: 25px;">
                {{ form.fir_lppo(class='form-check-input') }}
                {{ form.fir_lppo.label }}
              </span>
              <span style="margin-right: 25px;">
                {{ form.fir_lppc(class='form-check-input') }}
                {{ form.fir_lppc.label }}
              </span>
            </div>
            <br>
            <h5>TMA</h5>
            <div class="form-check">
              <span style="margin-right: 25px;">
                {{ form.tma_lppr(class='form-check-input') }}
                {{ form.tma_lppr.label }}
              </span>
              <span style="margin-right: 25px;">
                {{ form.tma_lppt(class='form-check-input') }}
                {{ form.tma_lppt.label }}
              </span>
              <span style="margin-right: 25px;">
                {{ form.tma_lpfr(class='form-check-input') }}
                {{ form.tma_lpfr.label }}
              </span>
              <span style="margin-right: 25px;">
                {{ form.tma_lpma(class='form-check-input') }}
                {{ form.tma_lpma.label }}
              </span>
              <span style="margin-right: 25px;">
                {{ form.tma_lppd(class='form-check-input') }}
                {{ form.tma_lppd.label }}
              </span>
              <span style="margin-right: 25px;">
                {{ form.tma_lpla(class='form-check-input') }}
                {{ form.tma_lpla.label }}
              </span>
              <span style="margin-right: 25px;">
                {{ form.tma_lphr(class='form-check-input') }}
                {{ form.tma_lphr.label }}
              </span>
            </div>
            <br>
            {{ form.submit(class='btn btn-success', style='float: right;') }}
          </form>
        </div>
      </div>
    </div>
  </div>
{% endblock %}

src/website/atcmentoring/templates/atcmentoring/edit_trainee.html
{% extends 'dashboard/base.html' %}

{% block styles %}
  {{super()}}
  <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap-select@1.13.9/dist/css/bootstrap-select.min.css">
  <link rel="stylesheet" href="https://unpkg.com/bootstrap-datepicker@1.9.0/dist/css/bootstrap-datepicker3.min.css">
{% endblock %}
{% block scripts %}
  {{super()}}
  <script   src="https://code.jquery.com/ui/1.11.3/jquery-ui.min.js"   integrity="sha256-xI/qyl9vpwWFOXz7+x/9WkG5j/SVnSw21viy8fWwbeE="   crossorigin="anonymous"></script>
  <script src="https://cdn.jsdelivr.net/npm/bootstrap-select@1.13.9/dist/js/bootstrap-select.min.js"></script>
  <script src="https://unpkg.com/bootstrap-datepicker@1.9.0/dist/js/bootstrap-datepicker.min.js"></script>
  <script>
    $(document).ready(function() {
      $('.date').datepicker({
          format: 'dd/mm/yyyy'
      });
    });

    trainee_firs = JSON.parse("{{trainee.firs|safe}}".replace(/'/g, '\"'))
    trainee_tmas = JSON.parse("{{trainee.tmas|safe}}".replace(/'/g, '\"'))

    if(Number("{{trainee.facility|safe}}") == 2)
      document.getElementById('facility').selectedIndex = "0"
    else if(Number("{{trainee.facility|safe}}") == 3)
      document.getElementById('facility').selectedIndex = "1"
    else if(Number("{{trainee.facility|safe}}") == 4)
      document.getElementById('facility').selectedIndex = "2"
    else if(Number("{{trainee.facility|safe}}") == 5)
      document.getElementById('facility').selectedIndex = "3"
    else if(Number("{{trainee.facility|safe}}") == 7)
      document.getElementById('facility').selectedIndex = "4"

    trainee_firs.forEach(element => {
      document.getElementById('fir_' + element).checked = true
    });

    trainee_tmas.forEach(element => {
      document.getElementById('tma_' + element).checked = true
    });

    if("{{trainee.atsimtest_status|safe}}" == 'not-assigned'){
      document.getElementById('atsimtest').selectedIndex = "0"
      date.style.display = "none"
    }
    else if("{{trainee.atsimtest_status|safe}}" == 'assigned'){
      document.getElementById('atsimtest').selectedIndex = "1"
      date.style.display = "none"
    }
    else{
      date.style.display = "block"
      date.value = "{{trainee.atsimtest_validity|safe}}".split(' ')[0]
      document.getElementById('atsimtest').selectedIndex = "2"
    }

    function atsimtest_check() {
      var select = document.getElementById("atsimtest");
      var option = select.options[select.selectedIndex].text
      // Get the output text
      var atsimtest_validity_form = document.getElementById("date");

      // If the checkbox is checked, display the output text
      if (option == "Complete"){
        atsimtest_validity_form.style.display = "block"
      } else {
        atsimtest_validity_form.style.display = "none"
      }
    }
  </script>
{% endblock %}

{% block page_content %}
  <div class="d-sm-flex align-items-center justify-content-between mb-4">
    <h1 class="h3 mb-0 text-gray-800">Edit {{trainee.name}} Trainee</h1>
  </div>
  <div class="row">
    <div class="col-xl-12 col-lg-12">
      <div class="card shadow mb-12">
        <div class="card-header py-3 d-flex flex-row align-items-center justify-content-between">

        </div>
        <div class="card-body">
          <form action="" method="post">
            {{ form.hidden_tag() }}
            <h5>Member</h5>
            <input class="form-control" value="{{trainee.cid}} - {{trainee.name}}" disabled></input>
            <br>
            <br>
            <h5>Facility</h5>
            {{ form.facility(class="form-control") }}
            <br>
            <h5>FIR</h5>
            <div class="form-check">
              {% for fir in mentor.firs %}
                <span style="margin-right: 25px;">
                  <input type="checkbox" class="form-check-input" name="fir_{{fir}}" id="fir_{{fir}}">
                  <label class="form-check-label" for="exampleCheck1">{{fir}}</label>
                </span>
              {% endfor %}
            </div>
            <br>
            <h5>TMA</h5>
            <div class="form-check">
              {% for tma in mentor.tmas %}
                <span style="margin-right: 25px;">
                  <input type="checkbox" class="form-check-input" name="tma_{{tma}}" id="tma_{{tma}}">
                  <label class="form-check-label" for="exampleCheck1">{{tma}}</label>
                </span>
              {% endfor %}
            </div>
            <br>
            <h5>ATSimTest</h5>
            {{ form.atsimtest(class="form-control", **{"onchange":"atsimtest_check()"}) }}
            <br>
            <div id="atsimtest_validity_form" class="input-group date" data-provide="datepicker">
              {{ form.atsimtest_validity(class="form-control hidden", placeholder="Validity", id="date") }}
              <span class="input-group-addon"><i class="glyphicon glyphicon-th"></i></span>
            </div>
            <br>
            {{ form.submit(class='btn btn-success', style='float: right;') }}
          </form>
        </div>
      </div>
    </div>
  </div>
{% endblock %}

src/website/atcmentoring/templates/atcmentoring/mentors_dashboard.html
{% extends 'dashboard/base.html' %}

{% block scripts %}
  {{super()}}
  <script src="{{ url_for('static', filename='js/jquery.dataTables.min.js') }}"></script>
  <script src="{{ url_for('static', filename='js/dataTables.bootstrap4.min.js') }}"></script>
  <script src="{{ url_for('static', filename='js/datatables.js') }}"></script>
  <script>
    var mentors = JSON.parse('{{mentors|tojson}}')
    var mentor = Object()
    function sendMentorToDialog(mentorcid){
      let modal = $("#deleteMentorModal")
      mentor = mentors.find(function(mentor){
        return mentor.cid == mentorcid
      })

      document.getElementById("deleteMentorModalLabel").innerHTML = 'Do you want delete '+ mentor.name +' from mentors?';
      modal.modal()
    }

    $('#deleteForm').submit(function(eventObj) {
      $(this).append('<input type="hidden" name="mentorid" value="'+mentor.cid+'">')
    })

  </script>
{% endblock %}

{% block page_content %}
  <div class="d-sm-flex align-items-center justify-content-between mb-4">
    <h1 class="h3 mb-0 text-gray-800">Manage Mentors</h1>
  </div>
  <div class="row">
    <!-- Area Chart -->
    <div class="col-xl-12 col-lg-12">
      <div class="card shadow mb-11">
        <!-- Card Header - Dropdown -->
        <div class="card-header py-3 d-flex flex-row align-items-center justify-content-between">
            <h6 class="m-0 font-weight-bold text-primary">Mentors</h6>
            <div class="dropdown no-arrow">
            <a class="dropdown-toggle" href="#" role="button" id="dropdownMenuLink" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                <i class="fas fa-ellipsis-v fa-sm fa-fw text-gray-400"></i>
            </a>
            <div class="dropdown-menu dropdown-menu-right shadow animated--fade-in" aria-labelledby="dropdownMenuLink">
                <div class="dropdown-header">Actions</div>
                <a class="dropdown-item" href="{{ url_for('atcmentoring.newmentor') }}">New</a>
            </div>
            </div>
        </div>
        <div class="card-body">
            <div class="table-responsive">
            <table class="table table-bordered" id="dataTable" width="100%" cellspacing="0">
                <thead>
                <tr>
                    <th>CID</th>
                    <th>Name</th>
                    <th>Limit</th>
                    <th># Trainees</th>
                    <th></th>
                </tr>
                </thead>
                <tfoot>
                <tr>
                    <th>CID</th>
                    <th>Name</th>
                    <th>Limit</th>
                    <th># Trainees</th>
                    <th></th>
                </tr>
                </tfoot>
                <tbody>
                  {% for mentor in mentors %}
                    <tr>
                      <td>{{ mentor.cid }}</td>
                      <td>{{ mentor.name }}</td>
                      <td>{{ mentor.limit }}</td>
                      <td>{{ mentor.trainees | length }}</td>
                      <td>
                        <button
                          title="Trainees"
                          style="background-color: transparent; border: none;"
                          onclick="window.location.href='mentors/{{ mentor.cid }}/trainees'">
                          <img width="24px" src="{{ url_for('static', filename='img/trainees.png') }}">
                        </button>
                        <button
                          title="Edit Mentor"
                          style="background-color: transparent; border: none;"
                          onclick="window.location.href='mentors/{{ mentor.cid }}/edit'">
                          <img width="24px" src="{{ url_for('static', filename='img/edit.png') }}">
                        </button>
                        <button
                          title="Delete Mentor"
                          class="open-deleteMentorModal"
                          style="background-color: transparent; border: none;"
                          onclick="sendMentorToDialog('{{mentor.cid}}')">
                          <img width="24px" src="{{ url_for('static', filename='img/delete.png') }}">
                        </button>
                      </td>
                    </tr>
                  {% endfor %}
                </tbody>
            </table>
            </div>
        </div>
      </div>
    </div>
  </div>
  <form id="deleteForm" action="./mentors/delete" method="POST">
    <div class="modal fade" id="deleteMentorModal" tabindex="-1" role="dialog" aria-labelledby="deleteMentorModalLabel" aria-hidden="true">
      <div class="modal-dialog" role="document">
        <div class="modal-content">
          <div class="modal-header">
            <h5 class="modal-title" id="deleteMentorModalLabel">Do you want delete ' + mentor.name + ' from mentors?</h5>
            <button class="close" type="button" data-dismiss="modal" aria-label="Close">
              <span aria-hidden="true">×</span>
            </button>
          </div>
          <div class="modal-footer">
            <button class="btn btn-secondary" type="button" data-dismiss="modal">Cancel</button>
            <input  class="btn btn-primary" style="color: #f8f9fc;" type="submit" value="Delete"></input>
          </div>
        </div>
      </div>
    </div>
  </form>
{% endblock %}

src/website/atcmentoring/templates/atcmentoring/mentors_public.html
{% extends 'public/base.html' %}
{% block page_content %}
  <div class="row" style="margin-top: 25px;">
    <div class="col-lg-2"></div>
    <div class="col-lg-10">
      <h2 class="hpage">ATC Mentors</h2>
      <p>Responsible in teaching the procedures to vACC Portugal Trainees.</p>
    </div>
    <div class="col-lg-2"></div>
  </div>
  <hr>
  <div class="container">
    <div class="col-lg-12 col-md-12">
        {% for mentor in mentors %}
        <div class="card">
          <div class="card-body">
            <h5 class="card-title">{{ mentor.cid }} - {{ mentor.name }}</h5>
            <div style="margin-left: 25px;">
              <h6>Current Trainees: {{mentor.trainees | length}}</h6>
              <h6>Limit: {{mentor.limit}}</h6>
              <h6>FIRs: {% for fir in mentor.firs%} {{fir}} {%endfor%}</h6>
              <h6>TMAs: {% for tma in mentor.tmas%} {{tma}} {%endfor%}</h6>
            </div>
          </div>
        </div>
        <br>
        {% endfor %}
    </div>
  </div>
{% endblock %}

src/website/atcmentoring/templates/atcmentoring/trainees.html
{% extends 'dashboard/base.html' %}

{% block scripts %}
  {{super()}}
  <script src="{{ url_for('static', filename='js/jquery.dataTables.min.js') }}"></script>
  <script src="{{ url_for('static', filename='js/dataTables.bootstrap4.min.js') }}"></script>
  <script src="{{ url_for('static', filename='js/datatables.js') }}"></script>
  <script>
    var trainee = undefined
    $(document).ready(function () {
      $(".open-deleteTrainieModal").click(function () {
        trainee = JSON.parse($(this).data('trainee').replace(/'/g, '"'));
        document.getElementById("deleteTrainieModalLabel").innerHTML = 'Do you want delete ' + trainee.name + ' from trainees?';
      });
    });

    $('#deleteForm').submit(function(eventObj) {
      $(this).append('<input type="hidden" name="trainieid" value="'+trainee.cid+'">')
    })

  </script>
{% endblock %}

{% block page_content %}
<div class="d-sm-flex align-items-center justify-content-between mb-4">
  <h1 class="h3 mb-0 text-gray-800">{{mentor.name}} Trainees</h1>
</div>
<div class="row">
  <!-- Area Chart -->
  <div class="col-xl-12 col-lg-12">
      <div class="card shadow mb-11">
        <!-- Card Header - Dropdown -->
        <div class="card-header py-3 d-flex flex-row align-items-center justify-content-between">
            <h6 class="m-0 font-weight-bold text-primary">Trainees List</h6>
            {% if current_user | belongs_to_group('admin', 'training_director', 'atcmentor_editor') %}
            <div class="dropdown no-arrow">
            <a class="dropdown-toggle" href="#" role="button" id="dropdownMenuLink" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                <i class="fas fa-ellipsis-v fa-sm fa-fw text-gray-400"></i>
            </a>
            <div class="dropdown-menu dropdown-menu-right shadow animated--fade-in" aria-labelledby="dropdownMenuLink">
                <div class="dropdown-header">Actions</div>
                <a class="dropdown-item" href="{{ url_for('atcmentoring.newtrainee', mentorid=mentor.cid) }}">Add</a>
            </div>
            </div>
            {% endif %}
        </div>
        <div class="card-body">
            <div class="table-responsive">
            <table class="table table-bordered" id="dataTable" width="100%" cellspacing="0">
                <thead>
                <tr>
                    <th>CID</th>
                    <th>Name</th>
                    <th>Training To Rating</th>
                    <th>ATSimTest Status</th>
                    <th>ATSimTest Validity</th>
                    {% if current_user | belongs_to_group('admin', 'training_director', 'atcmentor_editor') %}
                    <th></th>
                    {% endif %}
                </tr>
                </thead>
                <tfoot>
                <tr>
                  <th>CID</th>
                  <th>Name</th>
                  <th>Training To Rating</th>
                  <th>ATSimTest Status</th>
                  <th>ATSimTest Validity</th>
                  {% if current_user | belongs_to_group('admin', 'training_director', 'atcmentor_editor') %}
                  <th></th>
                  {% endif %}
                </tr>
                </tfoot>
                <tbody>
                  {% for trainee in mentor.trainees %}
                    <tr>
                      <td>{{ trainee.cid }}</td>
                      <td>{{ trainee.name }}</td>
                      <td>{{ get_facility(trainee.facility) }}</td>
                      {% if trainee.atsimtest_status == 'not-assigned' %}
                        <td><span style="color: red;">Not Assigned</span></td>
                      {% elif trainee.atsimtest_status == 'assigned' %}
                        <td><span style="color: orange;">Assigned</span></td>
                      {% elif trainee.atsimtest_status == 'complete' %}
                        <td><span style="color: green;">Passed</span></td>
                      {% else %}
                        <td></td>
                      {% endif %}
                      {% if trainee.atsimtest_status == 'complete' %}
                        <td>{{ trainee.atsimtest_validity }}</td>
                      {% else %}
                        <td></td>
                      {% endif %}
                      {% if current_user | belongs_to_group('admin', 'training_director', 'atcmentor_editor') %}
                      <td>
                        <button
                          title="Edit Trainee"
                          style="background-color: transparent; border: none;"
                          onclick="window.location.href='trainees/{{trainee.cid}}/edit'">
                          <img width="24px" src="{{ url_for('static', filename='img/edit.png') }}">
                        </button>
                        <button
                          title="Delete Trainee"
                          class="open-deleteTrainieModal"
                          style="background-color: transparent; border: none;"
                          data-toggle="modal"
                          data-target="#deleteTrainieModal"
                          data-trainee="{{trainee}}">
                          <img width="24px" src="{{ url_for('static', filename='img/delete.png') }}">
                        </button>
                      </td>
                      {% endif %}
                    </tr>
                  {% endfor %}
                </tbody>
              </table>
            </div>
        </div>
      </div>
  </div>
</div>
<form id="deleteForm" action="{{url_for('atcmentoring.delete_trainee', mentorid=mentor.cid)}}" method="POST">
  <div class="modal fade" id="deleteTrainieModal" tabindex="-1" role="dialog" aria-labelledby="deleteTrainieModalLabel" aria-hidden="true">
    <div class="modal-dialog" role="document">
      <div class="modal-content">
        <div class="modal-header">
          <h5 class="modal-title" id="deleteTrainieModalLabel">Do you want delete this trainee?</h5>
          <button class="close" type="button" data-dismiss="modal" aria-label="Close">
            <span aria-hidden="true">×</span>
          </button>
        </div>
        <div class="modal-footer">
          <button class="btn btn-secondary" type="button" data-dismiss="modal">Cancel</button>
          <input  class="btn btn-primary" style="color: #f8f9fc;" type="submit" value="Delete"></input>
        </div>
      </div>
    </div>
  </div>
</form>
{% endblock %}